@ECHO OFF
REM Run this file to initialize the solution.
REM It will alter the code with all of the various unique GUIDs and names that are necessary

REM Generate our GUIDs
ECHO Initializing project...
ECHO.
FOR /F "tokens=*" %%i in ('guidgen D') do SET ProductCode=%%i
FOR /F "tokens=*" %%i in ('guidgen D') do SET UpgradeCode=%%i
FOR /F "tokens=*" %%i in ('guidgen D') do SET PackageId=%%i

REM Fill in GUIDs
RegExReplace ".\BalancingPluginSetup\Server.wxs" "PRODUCT\-CODE\-GUID\-HERE" "%ProductCode%"
RegExReplace ".\BalancingPluginSetup\Server.wxs" "UPGRADE\-CODE\-GUID\-HERE" "%UpgradeCode%"

RegExReplace ".\BalancingPluginSetup\AddIn.xml" "PACKAGE\-ID\-GUID\-HERE" "%PackageId%"
RegExReplace ".\BalancingPluginSetup\AddIn.xml" "PRODUCT\-CODE\-GUID\-HERE" "%ProductCode%"

RegExReplace ".\BalancingPlugin\Balancer.cs" "PACKAGE\-ID\-GUID\-HERE" "%PackageId%"

RegExReplace ".\BalancingPluginWindowsSetup\BalancingPlugin.wxs" "PRODUCT\-CODE\-GUID\-HERE" "%ProductCode%"
RegExReplace ".\BalancingPluginWindowsSetup\BalancingPlugin.wxs" "UPGRADE\-CODE\-GUID\-HERE" "%UpgradeCode%"

REM Ask user for plug-in names
set /p HumanAuthorName="Enter your full name or organization (e.g. 'Jane Doe', 'Acme Inc.'): "
set /p HumanPluginName="Enter your plug-in name (e.g. 'Disk Space Equalizer'): "
ECHO.

REM Strip out the words plug-in from the user entered input
FOR /F "tokens=*" %%i in ('regexreplace . "\s*plug\-?in\s*" "" "%HumanPluginName%"') do SET HumanPluginName=%%i

REM Generate machine friendly names
FOR /F "tokens=*" %%i in ('regexreplace . "[^\w]" "" "%HumanAuthorName%"') do SET AuthorName=%%i
FOR /F "tokens=*" %%i in ('regexreplace . "[^\w]" "" "%HumanPluginName%"') do SET PluginName=%%i

SET AssemblyName=%AuthorName%.%PluginName%Plugin

REM Apply the names
RegExReplace ".\BalancingPlugin\BalancingPlugin.csproj" "ASSEMBLY\-NAME\-HERE" "%AssemblyName%"

RegExReplace ".\BalancingPluginSetup\Server.wxs" "ASSEMBLY\-NAME\-HERE" "%AssemblyName%"
RegExReplace ".\BalancingPluginSetup\Server.wxs" "AUTHOR\-HERE" "%HumanAuthorName%"
RegExReplace ".\BalancingPluginSetup\Server.wxs" "BALANCER\-NAME\-HERE" "%HumanPluginName%"

RegExReplace ".\BalancingPluginSetup\AddIn.xml" "BALANCER\-NAME\-HERE" "%HumanPluginName%"

RegExReplace ".\BalancingPlugin\Balancer.cs" "BALANCER\-NAME\-HERE" "%HumanPluginName%"

RegExReplace ".\BalancingPluginWindowsSetup\BalancingPlugin.wxs" "ASSEMBLY\-NAME\-HERE" "%AssemblyName%"
RegExReplace ".\BalancingPluginWindowsSetup\BalancingPlugin.wxs" "AUTHOR\-HERE" "%HumanAuthorName%"
RegExReplace ".\BalancingPluginWindowsSetup\BalancingPlugin.wxs" "BALANCER\-NAME\-HERE" "%HumanPluginName%"

REM Create and set output file name
SET OutputFileName=DrivePool.%PluginName%Plugin.Setup_1.0.0.1

RegExReplace ".\BalancingPluginSetup\Server.ddf" "OUTPUT\-FILE\-NAME\-HERE" "%OutputFileName%.wssx"
RegExReplace ".\BalancingPluginWindowsSetup\BalancingPluginWindowsSetup.wixproj" "OUTPUT\-FILE\-NAME\-HERE" "%OutputFileName%"

ECHO Done.
ECHO.
ECHO Open the solution and build it.
ECHO A plug-in file (.wssx) will be generated in .\BalancingPluginSetup\bin
ECHO.
PAUSE